/*
 * @(#)Light.java    Pzt 10 May 2010 14:32:03 EEST
 *
 * Light 3d for 3d world
 */
/*
*** This program wrote under GNU/General Public License ***

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.
*/
package net.dilmerkezi.light;

import java.awt.Color;

//custom
import net.dilmerkezi.point.*;


/**
 * @author Murat iNAN, dilmerkezi.net/eng.html
 */
public interface Light
{

    /**
     * @return Light origin 3D point
     */
    public Point3D getLightOriginPoint3D ();

    /** @return Light color*/
    public Color getLightColor ();
    
    /**
     * @param point Light point
     * @param normal Normalized point
     * @param camera Camera point
     *
     * @return Speculaded value
     */
    public double specular (Point3D point, Point3D normal, Point3D camera);

    /**
     * @param point Light point
     * @param normal Normalized point
     *
     * @return Diffused value
     */
    public double diffuse (Point3D point, Point3D normal);
        
}
/****************/
